using CaseAccountingBusinessLogic.BusinessLogics;
using CaseAccountingContracts.BusinessLogicContracts;
using CaseAccountingContracts.StoragesContracts;
using CaseAccountingDataBaseImplement.Implements;
using Microsoft.OpenApi.Models;

var builder = WebApplication.CreateBuilder(args);

//builder.Logging.SetMinimumLevel(LogLevel.Trace);
//builder.Logging.AddLog4Net("log4net.config");

// Add services to the container.
builder.Services.AddTransient<ICaseStorage, CaseStorage>();
builder.Services.AddTransient<IContractStorage, ContractStorage>();
builder.Services.AddTransient<IDealStorage, DealStorage>();
builder.Services.AddTransient<IHearingStorage, HearingStorage>();
builder.Services.AddTransient<ILawyerStorage, LawyerStorage>();
builder.Services.AddTransient<ISpecializationStorage, SpecializationStorage>();
builder.Services.AddTransient<IUserStorage, UserStorage>();

builder.Services.AddTransient<ICaseLogic, CaseLogic>();
builder.Services.AddTransient<IContractLogic, ContractLogic>();
builder.Services.AddTransient<IDealLogic, DealLogic>();
builder.Services.AddTransient<IHearingLogic, HearingLogic>();
builder.Services.AddTransient<ILawyerLogic, LawyerLogic>();
builder.Services.AddTransient<ISpecializationLogic, SpecializationLogic>();
builder.Services.AddTransient<IUserLogic, UserLogic>();

builder.Services.AddControllers();
// Learn more about configuring Swagger/OpenAPI at https://aka.ms/aspnetcore/swashbuckle
builder.Services.AddEndpointsApiExplorer();
builder.Services.AddSwaggerGen(c =>
{
	c.SwaggerDoc("v1", new OpenApiInfo
	{
		Title = "CaseAccountingRestApi",
		Version = "v1"
	});
});

var app = builder.Build();

// Configure the HTTP request pipeline.
if (app.Environment.IsDevelopment())
{
	app.UseSwagger();
	app.UseSwaggerUI(c => c.SwaggerEndpoint("/swagger/v1/swagger.json", "CaseAccountingRestApi v1"));
}

app.UseHttpsRedirection();

app.UseAuthorization();

app.MapControllers();

app.Run();
